/* --------------------------------------------------------
 Generated by Gunandi using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Gunandi (andri.gunandi1@gmail.com) 
 Date Created : 17/01/2019
 --------------------------------------------------------
*/
package com.portofolio.entity;

import static com.portofolio.base.adapter.DatabaseAdapter.Constant.*;

import  javax.persistence.*;
import  javax.validation.constraints.*;

import org.hibernate.annotations.ForeignKey;

import  lombok.AllArgsConstructor;
import  lombok.Getter;
import  lombok.NoArgsConstructor;
import  lombok.Setter;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.portofolio.entity.Departemen;
import com.portofolio.entity.Profile;
import com.portofolio.entity.vo.DokumenId;


@Entity
@Table(name = "Dokumen_M",indexes = {@Index(name = "Dokumen_M_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class Dokumen {
    
    @EmbeddedId
    private DokumenId id ;
    
    private static final String cDefNoDokumen = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "NoDokumen", columnDefinition = cDefNoDokumen)
    private String noDokumen;
    
    private static final String cDefNamaJudulDokumen = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG ;
    @Column(name = "NamaJudulDokumen", columnDefinition = cDefNamaJudulDokumen)
    @NotNull(message = "dokumen.namajuduldokumen.notnull")
    private String namaJudulDokumen;
    
    private static final String cDefNamaJudulDokumenSeri = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG ;
    @Column(name = "NamaJudulDokumenSeri", columnDefinition = cDefNamaJudulDokumenSeri)
    private String namaJudulDokumenSeri;
    
    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "dokumen.reportdisplay.notnull")
    private String reportDisplay;
    
    private static final String cDefDeskripsiDokumen = VARCHAR + AWAL_KURUNG + 500 + AKHIR_KURUNG ;
    @Column(name = "DeskripsiDokumen", columnDefinition = cDefDeskripsiDokumen)
    private String deskripsiDokumen;
    
    private static final String cDefTglDokumen = INTEGER ;
    @Column(name = "TglDokumen", columnDefinition = cDefTglDokumen)
    private Long  tglDokumen;
    
    private static final String cDefKdJenisDokumen =INTEGER;
    @Column(name = "KdJenisDokumen", columnDefinition = cDefKdJenisDokumen)
    @NotNull(message = "dokumen.kdjenisdokumen.notnull")
    private Integer kdJenisDokumen;
    
    private static final String cDefKdKategoryDokumen =INTEGER;
    @Column(name = "KdKategoryDokumen", columnDefinition = cDefKdKategoryDokumen)
    @NotNull(message = "dokumen.kdkategorydokumen.notnull")
    private Integer kdKategoryDokumen;
    
    private static final String cDefImageFile = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "ImageFile", columnDefinition = cDefImageFile)
    private String imageFile;
    
    private static final String cDefPathFile = VARCHAR + AWAL_KURUNG + 300 + AKHIR_KURUNG ;
    @Column(name = "PathFile", columnDefinition = cDefPathFile)
    private String pathFile;
    
    private static final String cDefQtyLampiran =INTEGER;
    @Column(name = "QtyLampiran", columnDefinition = cDefQtyLampiran)
    private Integer qtyLampiran;
    
    private static final String cDefKdDokumenHead =INTEGER;
    @Column(name = "KdDokumenHead", columnDefinition = cDefKdDokumenHead)
    private Integer kdDokumenHead;
    
    private static final String cDefKdRuangan = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KdRuangan", columnDefinition = cDefKdRuangan)
    @NotNull(message = "dokumen.kdruangan.notnull")
    private String kdRuangan;
    
    private static final String cDefisDokumenInOutInt =INTEGER;
    @Column(name = "isDokumenInOutInt", columnDefinition = cDefisDokumenInOutInt)
    private Integer isDokumenInOutInt;
    
    private static final String cDefRetensiDokumenTahun = FLOAT ;
    @Column(name = "RetensiDokumenTahun", columnDefinition = cDefRetensiDokumenTahun)
    private Float retensiDokumenTahun;
    
    private static final String cDefTglAwalBerlaku = INTEGER ;
    @Column(name = "TglAwalBerlaku", columnDefinition = cDefTglAwalBerlaku)
    private Long  tglAwalBerlaku;
    
    private static final String cDefTglAkhirBerlaku = INTEGER ;
    @Column(name = "TglAkhirBerlaku", columnDefinition = cDefTglAkhirBerlaku)
    private Long  tglAkhirBerlaku;
    
    private static final String cDefKdStatus =INTEGER;
    @Column(name = "KdStatus", columnDefinition = cDefKdStatus)
    private Integer kdStatus;
    
    private static final String cDefKdStatusBerkas =INTEGER;
    @Column(name = "KdStatusBerkas", columnDefinition = cDefKdStatusBerkas)
    private Integer kdStatusBerkas;
    
    private static final String cDefKodeExternal = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KodeExternal", columnDefinition = cDefKodeExternal)
    private String kodeExternal;
    
    private static final String cDefNamaExternal = VARCHAR + AWAL_KURUNG + 75 + AKHIR_KURUNG ;
    @Column(name = "NamaExternal", columnDefinition = cDefNamaExternal)
    private String namaExternal;
    
    private static final String cDefKdDepartemen = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "KdDepartemen", columnDefinition = cDefKdDepartemen)
    @NotNull(message = "dokumen.kddepartemen.notnull")
    private String kdDepartemen;
    
    private static final String cDefIsiDokumen = TEXT;
    @Column(name = "IsiDokumen", columnDefinition = cDefIsiDokumen)
    private String isiDokumen;
    
    private static final String cDefKdEdisi =INTEGER;
    @Column(name = "KdEdisi", columnDefinition = cDefKdEdisi)
    private Integer kdEdisi;
    
	private static final String cDefKdNegaraPP = INTEGER;
	@Column(name = "KdNegaraPP", columnDefinition = cDefKdNegaraPP)
	private Integer kdNegaraPP;
    
    private static final String cDefQtyPages =INTEGER;
    @Column(name = "QtyPages", columnDefinition = cDefQtyPages)
    private Integer qtyPages;
    
    private static final String cDefISBN = VARCHAR + AWAL_KURUNG + 50 + AKHIR_KURUNG ;
    @Column(name = "ISBN", columnDefinition = cDefISBN)
    private String iSBN;
    
    private static final String cDefImageCover = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "ImageCover", columnDefinition = cDefImageCover)
    private String imageCover;
    
    private static final String cDefImageCoverPathFile = VARCHAR + AWAL_KURUNG + 300 + AKHIR_KURUNG ;
    @Column(name = "ImageCoverPathFile", columnDefinition = cDefImageCoverPathFile)
    private String imageCoverPathFile;
    
    private static final String cDefNoRegisterAset = VARCHAR + AWAL_KURUNG + 255 + AKHIR_KURUNG ;
    @Column(name = "NoRegisterAset", columnDefinition = cDefNoRegisterAset)
    private String noRegisterAset;
    
    private static final String cDefKolasiDokumen = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG ;
    @Column(name = "KolasiDokumen", columnDefinition = cDefKolasiDokumen)
    private String kolasiDokumen;
    
    private static final String cDefKeteranganLainnya = VARCHAR + AWAL_KURUNG + 150 + AKHIR_KURUNG ;
    @Column(name = "KeteranganLainnya", columnDefinition = cDefKeteranganLainnya)
    private String keteranganLainnya;
    
    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "dokumen.statusenabled.notnull")
    private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "dokumen.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "dokumen.version.notnull")
    private Integer version;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Profile profile;
    
    @ManyToOne(fetch = FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
    		@JoinColumn(name = "KdProfile", referencedColumnName = "KdProfile", insertable = false, updatable = false),
    		@JoinColumn(name = "KdDepartemen", referencedColumnName = "KdDepartemen", insertable = false, updatable = false), })
    //@ForeignKey(name="none")
    private Departemen departemen;

    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdDokumenHead", referencedColumnName="KdDokumen",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Dokumen dokumenHead;
    

    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdJenisDokumen", referencedColumnName="KdJenisDokumen",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private JenisDokumen jenisDokumen;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdKategoryDokumen", referencedColumnName="KdKategoryDokumen",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private KategoryDokumen kategoryDokumen;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdRuangan", referencedColumnName="KdRuangan",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Ruangan ruangan;
    
    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdStatus", referencedColumnName="KdStatus",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Status status;    

    @ManyToOne(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdProfile", referencedColumnName="KdProfile",insertable=false, updatable=false),
        @JoinColumn(name="KdStatusBerkas", referencedColumnName="KdStatus",insertable=false, updatable=false),
    })
    //@ForeignKey(name="none")
     private Status statusBerkas;
    
	
}
